/*==============================================================================
 The Fraclet Programming Model - Fractal Component Model (fractal@objectweb.org)
 Copyright (C) 2002-2006 INRIA Futurs / LIFL
 Copyright (C) 2006-2007 Universitetet i Oslo

 This library is free software; you can redistribute it and/or modify it under 
 the terms of the GNU Lesser General Public License as published by the Free 
 Software Foundation; either version 2.1 of the License, or any later version.

 This library is distributed in the hope that it will be useful, but WITHOUT ANY 
 WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License along 
 with this library; if not, write to the Free Software Foundation, Inc., 
 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

 Initial developer(s): Romain Rouvoy
 Contributor(s): 
 =============================================================================*/
package org.objectweb.fractal.fraclet.extensions;

import static java.lang.annotation.RetentionPolicy.RUNTIME;
import static org.objectweb.fractal.fraclet.types.Constants.EMPTY;

import java.lang.annotation.Retention;

import spoon.aval.annotation.structure.AValTarget;
import spoon.aval.annotation.structure.Prohibits;
import spoon.reflect.declaration.CtClass;

/**
 * Description of a component container.
 * 
 * @author Romain Rouvoy (Initial developer)
 * @version $Revision$
 */
@Prohibits(Data.class)
@Retention(RUNTIME)
@AValTarget(CtClass.class)
public @interface Membrane {
    /**
     * Identifier of the component container.
     * @return Logical name of the container hosting the component.
     */
    String controller() default EMPTY;

    /**
     * Identifier of the component factory.
     * @return Logical name of the factory used to instantiate the component.
     */
    String template() default EMPTY;
}