package org.objectweb.fractal.adl.spoonlet.composite;

import org.objectweb.fractal.document.Factory;
import org.objectweb.fractal.xml.AbstractDocumentGenerator;

/**
 * @author Romain Rouvoy (Initial Developer)
 * @version $Revision$
 */
public class DefinitionGenerator extends AbstractDocumentGenerator {
    /** Default instance of the Fractal ADL description factory. */
    private static final Factory composite = new Factory();

    /* (non-Javadoc)
     * @see org.objectweb.fractal.xml.AbstractDocumentGenerator#factory()
     */
    protected Factory factory() {
        return composite;
    }

    /**
     * Provides the instance of the default factory.
     * 
     * @return the reference of the Fractal ADL description factory.
     */
    public static final Factory composite() {
        return composite;
    }
}
